function [ T ] = DH( theta, d, r, alpha )
% Returns the Denavit-Hartenberg transformation matrix of the parameters
% theta, d, r and alpha.
%   theta   - Rotation about the z-axis
%   d       - Translation in the z-direction
%   r       - Translation in the x-direction
%   alpha   - Rotation about the x-axis

T  = [cos(theta), -sin(theta)*cos(alpha), sin(theta)*sin(alpha), r*cos(theta);
    sin(theta), cos(theta)*cos(alpha), -cos(theta)*sin(alpha), r*sin(theta);
    0, sin(alpha), cos(alpha), d;
    0, 0, 0, 1];

end