function [K,q0,dq0,qend,dqend] = Kfun(Kin, q0, dq0, qend, dqend)
% 
% Changes the first coefficient of each row in K such that initial
% conditions, q0, are satisfied
% Assumes that first element of the input q's are theta
% Returns the inverse function if nargin = 1

if nargout > 1 && nargin > 1
    error('Either nargout or nargin must be one');
end

if nargin > 1
    qvec = [q0(2:end);dq0(2:end);qend(2:end);dqend(2:end)];
    M = (length(Kin(:)) + length(qvec(~isnan(qvec))))/(length(q0)-1) - 1;
    K1 = q0(1):(qend(1)-q0(1))/M:qend(1);   % First coordinate is linear
    K2 = zeros(length(q0)-1, 4 + size(Kin,2));
    K2(:,1)         = q0(2:end);
    K2(:,2)         = q0(2:end)+dq0(2:end)/M;
%     K2(:,3)         = q0(2:end)+dq0(2:end)/M+d2q0(2:end)/(M*(M-1));
    K2(:,3:end-2)   = Kin;
%     K2(:,end-2)     = qend(2:end)+dqend(2:end)/M+d2qend(2:end)/(M*(M-1));
    K2(:,end-1)     = qend(2:end)-dqend(2:end)/M;
    K2(:,end)       = qend(2:end);
    K = [K1;K2];
elseif nargout > 1
    M = size(Kin,2) - 1;
    q0 = Kin(:,1);
    qend = Kin(:,end);
    dq0 = M*(Kin(:,2)-Kin(:,1));
    dqend = M*(Kin(:,end)-Kin(:,end-1));
%     d2qend = M*(M-1)*(Kin(:,end)-2*Kin(:,end-1)+Kin(:,end-2));
%     d2q0 = M*(M-1)*(Kin(:,3)-2*Kin(:,2)+Kin(:,1));
%     K = Kin(:,4:end-3);
    K = Kin(:,3:end-2);
end

end