function q34 = initialPosition(q1, d)
% Calculates the shoulder and elbow angle of the free arm to grip a bar at
% distance d from the front grip. Must be rewritten if bar can change
% height.

parameters

lf = l(7)+l(8);
if abs(lf*sin(q1)) < d/2
    error('Impossible to reach');
end

a = sqrt(lf^2+d^2-2*lf*d*cos(pi/2-abs(q1)));

t1 = acos((lf^2+a^2-d^2)/(2*lf*a));
t3 = acos((l(7)^2 + a^2 - l(8)^2)/(2*l(7)*a));
t4 = acos((l(7)^2 + l(8)^2 - a^2) / (2*l(7)*l(8)));

q3 = sign(q1)*(pi-t1-t3);
q4 = sign(q1)*(pi-t4);

q34 = [q3,q4]';

end