function [Dsym, Csym, Gsym] = calculateDynamics(obj)
    
%     syms caller
%     folder = [cd, '\Robot\@Robot\'];
%     folder = [cd, '\SystemMatrices\'];

    q = obj.q;
    dq = obj.dq;

    N = obj.N;
    
    obj.jacobianSym();

    disp('Calculating Inertia matrix')
    % Inertia matrix
    Dsym = sym(zeros(N));
    Dsyminv = sym(zeros(N));
    for i=1:obj.n
        limb = obj.limbs(i);
        for j=i:limb.n
            link = limb.links(j);
            if ~isempty(link.m)
                Jv = link.Jvel; Jw = link.Jrot; m = link.m; I = link.I0;
                Dsym = Dsym + m*(Jv')*Jv + Jw'*I*Jw;
            end
        end
    end

    disp('Calculating Coriolis matrix')
    % Coriolis/centrifugal
    Csym = sym(zeros(N));
%     CsymMat = reshape(sym(zeros(N, N*N)), [N,N,N]);
    CsymNew = sym(zeros(N, N*N));

    for i=1:N
%         disp(['i = ', num2str(i)])
        for j=i:N
%             disp(['j = ', num2str(j)])
            for k=1:N
%                 disp(['k = ', num2str(k)])
                if obj.N < 5
                    CsymMat(i,j,k) = simplify(diff(Dsym(i,j), q(k)));
                else
                    CsymMat(i,j,k) = diff(Dsym(i,j), q(k));
                end
%                 CsymNew(i,j+N*(k-1)) = simplify(diff(Dsym(i,j), q(k)));
%                 temp = diff(Dsym(i,j), q(k));
%                 eval(['Csym', num2str(i), num2str(j), num2str(k), ' = temp;']);
%                 eval(['save(''', folder, 'Csym\Csym', num2str(i), num2str(j), num2str(k), ''', ''Csym', num2str(i), num2str(j), num2str(k), ''');']);
                if i~=j
                    CsymMat(j,i,k) = CsymMat(i,j,k);
%                     CsymNew(j,i+N*(k-1)) = CsymNew(i,j+N*(k-1));
                end
            end
        end
    end


%         disp('Saving Dfun')
%         obj.Dfun = matlabFunction(Dsym, 'vars', {obj.q}, 'file', [folder, 'Dfun'], 'outputs', {'D'});
%         obj.DfunTop = matlabFunction(Dsym(1,:), 'vars', {obj.q}, 'file', [folder, 'DfunTop'], 'outputs', {'DTop'});
%         matlabFunction(Dsym, 'vars', {caller, obj.q}, 'file', [folder, 'Dfun'], 'outputs', {'D'});
%         matlabFunction(Dsym(1,:), 'vars', {caller, obj.q}, 'file', [folder, 'DfunTop'], 'outputs', {'DTop'});

    for k=1:N
        for j=1:N
            for i=1:N
%                 CsymOld(k,j) = Csym(k,j) + 1/2*simplify(diff(Dsym(k,j), q(i)) + diff(Dsym(k,i), q(j)) + diff(Dsym(i,j), q(k)))*dq(i);
                if obj.N < 5
                    Csym(k,j) = Csym(k,j) + 1/2*simplify(CsymMat(k,j,i) + CsymMat(k,i,j) - CsymMat(i,j,k))*dq(i);
                else
                    Csym(k,j) = Csym(k,j) + 1/2*(CsymMat(k,j,i) + CsymMat(k,i,j) - CsymMat(i,j,k))*dq(i);
                end
%                 Csym(k,j) = Csym(k,j) + 1/2*simplify(CsymNew(k,j+N*(i-1)) + CsymNew(k,i+N*(j-1)) - CsymNew(i,j+N*(k-1)))*dq(i);
            end
        end
    end
    clear CsymMat

%         disp('Saving Cfun')
%         obj.Cfun = matlabFunction(Csym, 'vars', {obj.q, obj.dq}, 'file', [folder, 'Cfun'], 'outputs', {'C'});
%         obj.CfunTop = matlabFunction(Csym(1,:), 'vars', {obj.q, obj.dq}, 'file', [folder, 'CfunTop'], 'outputs', {'CTop'});
%         matlabFunction(Csym, 'vars', {caller, obj.q, obj.dq}, 'file', [folder, 'Cfun'], 'outputs', {'C'});
%         matlabFunction(Csym(1,:), 'vars', {caller, obj.q, obj.dq}, 'file', [folder, 'CfunTop'], 'outputs', {'CTop'});

    disp('Calculating Gravity matrix')
    % Potential energy
    g = obj.g;
    V = sym(0);
    for i=1:obj.n
        limb = obj.limbs(i);
        for j=1:limb.n
            link = limb.links(j);
            if ~isempty(link.m)
                V = V + g'*link.r0*link.m;
            end
        end
    end
    Gsym = sym(zeros(length(q), 1));
    for i=1:length(q)
        Gsym(i) = diff(V, q(i));
    end

%         disp('Saving Gfun')
%         obj.Gfun = matlabFunction(Gsym, 'vars', {obj.q}, 'file', [folder, 'Gfun'], 'outputs', {'G'});
%         obj.GfunTop = matlabFunction(Gsym(1,:), 'vars', {obj.q}, 'file', [folder, 'GfunTop'], 'outputs', {'GTop'});
%         matlabFunction(Gsym, 'vars', {caller, obj.q}, 'file', [folder, 'Gfun'], 'outputs', {'G'});
%         matlabFunction(Gsym(1,:), 'vars', {caller, obj.q}, 'file', [folder, 'GfunTop'], 'outputs', {'GTop'});
    
    obj.functionsUpdated = 1;
end