function T = torque(obj, q, dq, d2q)
% Computes the torque required to achieve the trajectory defined by q, dq
% and d2q.
% Expects q, dq, d2q to be functions of time in dim 1
% Needs optimization

T = zeros(size(q,1),size(obj.Dfun(q(1,:)'),1));
for i=1:length(q)
	qt = q(i,:)'; dqt = dq(i,:)'; d2qt = d2q(i,:)'; % Evaluated at time t(i)
    T(i,:) = obj.Dfun(qt)*d2qt + obj.Cfun(qt, dqt)*dqt + obj.Gfun(qt);
end

end