function [Psi,dPsi,d2Psi] = PsiFun(t,K)
% Note: qr-functions must be copyed again if changed!
% K is a matrix containing the bezier coefficients for the independent
% coordinates. K(i,:) - coefficients for qi.
rset = [3,4];
mset = [1,2,5,6];

Psi = zeros(length(t), 6);
Psi(:,mset) = bezier(t,K(mset,:));
Psi(:,rset) = fqrFun(Psi(:,[1,2])')';

if nargout > 1
    dPsi = zeros(length(t),6);
    dPsi(:,mset) = dbezier(t,K(mset,:));
    dPsi(:,rset) = dfqrFun(Psi(:,[1,2])',dPsi(:,[1,2])')';
end
if nargout > 2
    d2Psi = zeros(length(t),6);
    d2Psi(:,mset) = d2bezier(t,K(mset,:));
    d2Psi(:,rset) = d2fqrFun(Psi(:,[1,2])',dPsi(:,[1,2])',d2Psi(:,[1,2])')';
end
end




