function fqr = calcRedundant(q1,q2,folder)
if nargin < 1 || isempty(q1) || isempty(q2)
    syms q1 q2
end
if nargin < 3
    folder = [];
end

parameters
l7 = l(7);
l8 = l(8);
xb = pBar(1);
yb = pBar(2);

xh = l8*sin(q1) + l7*sin(q1+q2);
yh = l8*cos(q1) + l7*cos(q1+q2);

% L1sq_1 = l7^2+l8^2-2*l7*l8*cos(sym(pi)-q2);
L1sq_2 = xh^2+yh^2;

% L1_1 = sqrt(L1sq_1);
L1_2 = sqrt(L1sq_2);

theta_a1 = asin(l8/L1_2*sin(sym(pi)-q2));
% theta_b1 = asin(l7/L1_2*sin(sym(pi)-q2));

% L2sq_1 = l7^2+l8^2-2*l7*l8*cos(sym(pi)-t4);
L2sq_2 = (xh-xb)^2 + (yh-yb)^2;

% L2_1 = sqrt(L2sq_1);
L2_2 = sqrt(L2sq_2);

t4 = acos( (L2sq_2 - l8^2 - l7^2) / (2*l7*l8) );

theta_a2 = asin(l8/L2_2*sin(sym(pi)-t4));
% theta_b2 = asin(l7/L2_2*sin(sym(pi)-t4));

theta_c = acos( (L1sq_2 + L2sq_2 - xb^2) / (2*L1_2*L2_2) );

theta_4 = acos( (L2sq_2 - l8^2 - l7^2) / (2*l7*l8) );
theta_3 = sym(pi) - theta_a1-theta_c - theta_a2;

% dtheta_4 = jacobian(theta_4, [q1,q2]);
% dtheta_3 = jacobian(theta_3, [q1,q2]);
% 
% d2theta_4 = jacobian(dtheta_4, [q1,q2]);
% d2theta_3 = jacobian(dtheta_3, [q1,q2]);

fqr = [theta_3; theta_4];



end