function createFunctions

global dirs
dirs = fun_manage_dirs;

if ~(exist('PhiVec','file') && exist('dPhiVec','file') && exist('d2PhiVec','file'))
    error('PhiVec, dPhiVec and d2PhiVec must be in search path');
end
% clear all

parameters;

% 6 DOF model
gorilla = gorilla_6dof;
gorilla.setSync(@PhiVec, @dPhiVec, @d2PhiVec);

[D,C,G] = gorilla.calculateDynamics();
gorilla.saveDynamics(D,C,G,[dirs.generated_functions,filesep],'6');

% 4 DOF model
% gorilla4 = gorilla_6dof;
% fqr = calcRedundant(gorilla.q(1),gorilla.q(2));
% q = gorilla.q;
% dq = gorilla.dq;
% d2q = gorilla.d2q;
% Fx = pBar(1) - l(8)*sin(q(1)) - l(7)*sin(sum(q(1:2))) - l(7)*sin(sum(q(1:3))) - l(8)*sin(sum(q(1:4)));
% Fy = pBar(2) - l(8)*cos(q(1)) - l(7)*cos(sum(q(1:2))) - l(7)*cos(sum(q(1:3))) - l(8)*cos(sum(q(1:4)));
% F_constraint = [Fx;Fy];
% 
% B = [zeros(1,5); eye(5)];
% [D4, C4, G4, B4] = reduceDynamics(D, C, G, B, fqr, F_constraint,q,dq,d2q,[3,4]);
% gorilla4.saveDynamics(D4,C4,G4,[cd, '\SystemMatrices\'],'4');
% disp('Saving B')
% obj.Bfun = matlabFunction(B4, 'vars', {gorilla4.q}, 'file', [dir.gorilla, filesep, 'Bfun', '4'], 'outputs', {'B'});


end