clear all
gorilla = gorilla_6dof;
gorilla.setSync(@PhiVec, @dPhiVec, @d2PhiVec);
gorilla.setDynamics(@Dfun6, @Cfun6, @Gfun6, @DfunTop6, @CfunTop6, @GfunTop6);

gorilla4 = gorilla_6dof;
gorilla4.setSync(@PsiFun, @dPsiFun, @d2PsiFun);
gorilla4.setDynamics(@Dfun4, @Cfun4, @Gfun4);

gorilla2 = gorilla_6dof;
gorilla2.setSync(@PhiVec, @dPhiVec, @d2PhiVec);
gorilla2.setDynamics(@Dfun6, @Cfun6, @Gfun6, @DfunTop6, @CfunTop6, @GfunTop6);
gorilla2.calculateCoM

% Relabeling
Trans1 = [1,1,1,1,0,0;
0,0,0,-1,0,0;
0,0,-1,0,0,0;
0,-1,0,0,0,0;
0,0,-1,0,1,0;
0,0,0,0,0,1];
Trans2 = [-pi,0,0,0,pi,0]';

q12 =[0.196349540849362;2.471416316344248];

fps = 30;
tspan = 0:1e-3:2;

parameters

epsilon = pi/32;
theta0 = -pi/3;
thetaend = asin(d/(2*(l(7)+l(8)))) + epsilon;
% thetaend = pi/3 + 0.1;

% Lf = @(epsilon) sqrt(l(7)^2+l(8)^2-2*l(7)*l(8)*cos(pi-epsilon));
% betaFun = @(epsilon) (-Lf(epsilon)^2+(l(7)+l(8))^2+d^2)/(2*(l(7)+l(8))*d);
% alpha1Fun = @(epsilon) asin((l(8)*sin(pi-epsilon))/Lf(epsilon));
% alpha2Fun = @(epsilon) (-d^2+(l(7)+l(8))^2+Lf(epsilon)^2)/(2*(l(7)+l(8))*Lf(epsilon)^2);
% 
% theta1Fun = @(epsilon) betaFun(epsilon);
% theta3Fun = @(epsilon) pi - alpha1Fun(epsilon) - alpha2Fun(epsilon);

% q0 = [-0.8349, -0.2683, -0.6266, -0.9189, 0.1627, 0]'
q0 = [theta0, 0, initialPosition(theta0,d)', 0, 0]';
qend = [thetaend, 0.01, fqrFun([thetaend,0.01]')', 0, 0]';
dq0 = zeros(6,1);
dqend = 0.5*[1,1,1,1,1,1]';
% d2q0 = zeros(6,1);
% d2qend = zeros(6,1);

M = 5;  % Bezier curve degree
K0 = zeros(5,M+1-4);
Kvar = K0;
   
% Swing phase
% x0 = [q0(1);dq0(1)];
% xend = [qend(1); dqend(1)];
% Kvar = HeuristicSearch(K0, @(Kvar) heuristic(gorilla, Kfun(Kvar, q0, dq0, qend, dqend), x0, xend));
% K = Kfun(Kvar, q0, dq0, d2q0, qend, dqend, d2qend);
K = Kfun(Kvar, q0, dq0, qend, dqend);


% Animate
parameters

for i=1:10
    opts = odeset('Events', @(t,x) eventFunction(t,x,thetaend));
    [t_swing,q_swing,dq_swing,d2q_swing,tau] = gorilla.simulateReduced(K, tspan, [q0(1),dq0(1)], [qend(1),dqend(1)], opts);

    qe_12 = q_swing(end,[1,2])'; dqe_12 = dq_swing(end,[1,2])'; 
%     d2qe_12 = d2q_swing(end,[1,2])';
    
    e_d = dq_swing(end,[3,4])' - dfqrFun(qe_12,dqe_12);
%     e_d2 = d2q_swing(end,[3,4])' - d2fqrFun(qe_12,dqe_12,d2qe_12);
    
    
    dqend([3,4]) = dqend([3,4]) - 0.5*(qend(1)-q0(1))*e_d;
%     d2qend([3,4]) = d2qend([3,4]) - 0.3*(qend(1)-q0(1))^2*e_d2;
    
%     K = Kfun(Kvar, q0, dq0, d2q0, qend, dqend, d2qend);
    K = Kfun(Kvar, q0, dq0, qend, dqend);
end

% M = gorilla.animate(t, q, fps*4);
% movie2avi(M, 'gorilla_6dof_bezier_derivative.avi', 'fps', fps, 'quality', 100);

% Loop phase
t_loop = (t_swing(end):1e-3:t_swing(end)+0.5)';
[Kvars,q0s,dq0s,qends,dqends] = Kfun(K);

q0l = q_swing(end,:)';
dq0l = (t_loop(end)-t_loop(1))*dq_swing(end,:)';
d2q0l = (t_loop(end)-t_loop(1))^2*d2q_swing(end,:)';

% qend = [q12; fqrFun(q12); -pi; 0];
qendl = [pi-sum(q0l([1,3,4])); q0l(4); q0l(3); 0; -pi+q0l(3); q0l(6)];
% qendl = [pi-sum(q0([1,3,4])); q0(4)+0.1; q0(3); 0; -0.5;-0.5];
% qendl = Trans1*q0 + Trans2;
dqendl = (t_loop(end)-t_loop(1))*0*[-1,1,-1,-1,1,1]';
% d2qend = (t_loop(end)-t_loop(1))^2*zeros(size(q0));

Kl = [q0l, q0l+dq0l/5, q0l-dq0l/5, qendl-dqendl/5, qendl-dqendl/5, qendl];
[q_loop, dq_loop, d2q_loop] = PsiFun(t_loop, Kl);
tau_loop = gorilla4.torque(q_loop, dq_loop, d2q_loop);
tau_loop2 = zeros(size(q_loop,1), 5);
for i=1:size(q_loop,1)
    tau_loop2(i,:) = (Bfun4(q_loop(i,:)')\tau_loop(i,:)');
end


% ====== Second swing phase =======
switchAngle = @(q) [-pi+sum(q(1:4)); -q(4:-1:2); pi-q(3)+q(5); q(6)];
q0s2 = switchAngle(q_loop(end,:)');
q0s2 = Trans1*q_loop(end,:)'+Trans2;
dq0s2 = switchAngle(dq_loop(end,:)');
dq0s2 = Trans1*dq_loop(end,:)';
% dq0s2 = dq_loop(end,:)';

qends2 = qends;
dqends2 = dqends;
% d2qends2 = d2qends;

Ks2 = Kfun(Kvar, q0s2, dq0s2, qends2, dqends2);
% Kvar = zeros(6,0);
% Ks2 = Kfun(Kvar, q0s2, dq0s2, qends2, dqends2);


% Relabel coordinates
T0_new = gorilla2.T0;
T0_new(1:3,4) = subs(gorilla2.limbs(1).links(end).T0(1:3,4),gorilla2.q,q_loop(end,:));
gorilla2.relabel(T0_new);
gorilla2.calculateCoM();

opts = odeset('Events', @(t,x) eventFunction(t,x,thetaend));
[t_swing2,q_swing2,dq_swing2,d2q_swing2,tau2] = gorilla2.simulateReduced(Ks2, tspan+t_loop(end), [q0s2(1),dq0s2(1)], [qends2(1),dqends2(1)], opts);
% [t_swing2,q_swing2,dq_swing2,d2q_swing2,tau2] = gorilla.simulateReduced(Ks2, tspan, [q0s2(1),dq0s2(1)], [qends2(1),dqends2(1)]);


% movie2avi([M1,M2], 'gorilla_6dof_loop2.avi', 'fps', fps, 'quality', 100);
Trans1 = [1,1,1,1,0,0;
0,0,0,-1,0,0;
0,0,-1,0,0,0;
0,-1,0,0,0,0;
0,0,-1,0,1,0;
0,0,0,0,0,1];
Trans2 = [-pi,0,0,0,pi,0]';

qt = (Trans1\(q_swing2'-Trans2(:,ones(1,size(q_swing2,1)))))';
dqt = (Trans1\dq_swing2')';
d2qt = (Trans1\dq_swing2')';

t = [t_swing; t_loop; t_swing2];
q = [q_swing; q_loop; qt];
dq = [dq_swing; dq_loop; dqt];
d2q = [d2q_swing; d2q_loop; d2qt];

figure(1);
plot(t, q);
figure(2);
plot(t, dq);
figure(3);
plot(t, d2q);

fps = 20;
M1 = gorilla.animate(t_swing, q_swing, fps,0,0,0);
% hold on
M2 = gorilla.animate(t_loop-t_swing(end), q_loop, fps,0,0,0);
% hold on
M3 = gorilla2.animate(t_swing2-t_loop(end), q_swing2, fps,0,0,0);
hold off
% 
% r0Fun = matlabFunction(gorilla.r0, 'vars', {gorilla.q});
% r0Fun2 = matlabFunction(gorilla2.r0, 'vars', {gorilla.q});
% 
% com_swing = zeros(3,size(t_swing,1));
% for i=1:length(t_swing)
%     com_swing(:,i) = r0Fun(q_swing(i,:)');
% end
% 
% com_loop = zeros(3,size(t_loop,1));
% for i=1:length(t_loop)
%     com_loop(:,i) = r0Fun(q_loop(i,:)');
% end
% 
% com_swing2 = zeros(3,size(t_swing2,1));
% for i=1:length(t_swing2)
%     com_swing2(:,i) = r0Fun2(q_swing2(i,:)');
% end
% 
% com_traj = [com_swing, com_loop, com_swing2];
% hold all
% plot(com_traj(1,:), com_traj(3,:), 'r');
