% clear all
close all

global t_star                                   % Desired trajectory (time)
global theta_star dtheta_star d2theta_star      % Desired trajectory (theta)
global q_star dq_star d2q_star                  % Desired trajectory (all)
global Pmin                                     % Optimal coefficients for scalar controller
global theta_s Psi1_s Psi2_s                    % Pre-calculated integral values
global index
% global phi_star                               % Angle of point in phase plot
% global Psi_precalc

load('indices.mat');
load('ideal.mat');
load('opt.mat');
load('integral.mat');
load('model.mat');

n = size(q_star,1);

T = t_star(end);

if n == 2               % Inverted pendulum
%     delta = [0, 0, 0, 0];               % No errors
%     delta = [-0.1, 0.1, 0, 0];          % init1: Errors in (theta,dtheta)
%     delta = [0, 0, -0.1, 0.1];          % init2: Errors in (y,dy) 
    delta = [-0.1, 0.1, -0.1, 0.1];     % init3: Errors in (theta,dtheta,y,dy)
%     delta = [-0.1, -0.2, 2, 0.5];        % init4: Errors in (theta,dtheta,y,dy)
    theta0 = theta_star(1) + delta(1);
    dtheta0 = dtheta_star(1) + delta(2);
    
    q0error = [delta(3);0];
    dq0error = [delta(4);0];
   
    c_gain = [10, 7];
    
elseif n == 6           % Gorilla robot
    theta0 = theta_star(1);
    dtheta0 = dtheta_star(1);
   
%     delta = [0, 0, 0, 0];               % No errors
%     delta = [-0.1, 0.1, 0, 0];          % init1: Errors in (theta,dtheta)
%     delta = [0, 0, -0.1, 0.1];          % init2: Errors in (y,dy) 
    delta = [-0.1, 0.1, -0.1, 0.1];     % init3: Errors in (theta,dtheta,y,dy)
%     delta = [0, 0, 0.1, 0.2];     % init3: Errors in (theta,dtheta,y,dy)
%     delta = [-0.1, -0.2, 2, 0.5];        % init4: Errors in (theta,dtheta,y,dy)
    
    theta0 = theta_star(1) + delta(1);
    dtheta0 = dtheta_star(1) + delta(2);
    
    y0 = [delta(3),0,0,0,0]';
    dy0 = [delta(4),0,0,0,0]';
    q0error = [0;y0];
    dq0error = [0;dy0];
    
    c_gain =[
       90.0000         0         0         0         0   19.0000         0         0         0         0
             0   20.0000         0         0         0         0    9.0000         0         0         0
             0         0   24.0000         0         0         0         0   11.0000         0         0
             0         0         0   14.0000         0         0         0         0    9.0000         0
             0         0         0         0    6.0000         0         0         0         0    7.0000];
else
    error('System dimensions not recognized');
end

q0 = PhiFun(theta0) + q0error
dq0 = dPhiFun(theta0)*dtheta0 + dq0error

     