function fun_compute_linearization

global q dq d2q
global xi xi_star nu
global theta dtheta d2theta
global y dy v
global n
global Msym Csym Gsym Bperpsym
global alpha beta gamma

global dirs

fun = Bperpsym*(Msym*d2q + Csym*dq + Gsym);     % Function of q,dq,d2q

tic
% fun = subs(fun,xi,xi_star+nu);                  % Function of theta,dtheta,d2theta,y,dy,d2y
g = alpha*d2theta+beta*dtheta^2+gamma-subs(fun,xi,xi_star+nu);    % Difference between fun with errors and alpha-beta-gamma equation
g_lin = jacobian(g,[theta;dtheta;d2theta;y;dy;v]);
toc

gtheta = g_lin(1);
gdtheta = g_lin(2);
gd2theta = g_lin(3);
gy = g_lin(4:4+n-2);
gdy = g_lin(4+(n-1):4+2*(n-1)-1);
gv = g_lin(4+2*(n-1):end);

gI = (dtheta*gdtheta - d2theta*gtheta)/(2*(dtheta^2+d2theta^2));

% Experimental method
gy2 = jacobian(fun,q);
gdy2 = jacobian(fun,dq);
gv2 = jacobian(fun,d2q);


disp('Generating gI')
matlabFunction(gI,'vars',{theta,dtheta,d2theta,y,dy,v},'file',[dirs.generated_functions, filesep, 'gIFun']);
disp('Generating gy')
matlabFunction(gy,'vars',{theta,dtheta,d2theta,y,dy,v},'file',[dirs.generated_functions, filesep, 'gyFun']);
disp('Generating gdy')
matlabFunction(gdy,'vars',{theta,dtheta,d2theta,y,dy,v},'file',[dirs.generated_functions, filesep, 'gdyFun']);
disp('Generating gv')
matlabFunction(gv,'vars',{theta,dtheta,d2theta,y,dy,v},'file',[dirs.generated_functions, filesep, 'gvFun']);
disp('Done!')

% disp('k1');
% k1 = 2*dtheta*(gI - beta)/alpha;
% disp('matlabFunction(k1)');
% matlabFunction(k1,'vars',{theta,dtheta,d2theta,y,dy,v},'file',[dirs.generated_functions, filesep, 'k1fun']);
% k1 = subs(k1,[y,dy,v],[0,0,0]);
% 
% disp('k2');
% k2 = 2*dtheta*gy/alpha;
% disp('matlabFunction(k2)');
% matlabFunction(k2,'vars',{theta,dtheta,d2theta,y,dy,v},'file',[dirs.generated_functions, filesep, 'k2fun']);
% k2 = subs(k2,[y,dy,v],[0,0,0]);
% 
% disp('k3');
% k3 = 2*dtheta*gdy/alpha;
% disp('matlabFunction(k3)');
% matlabFunction(k3,'vars',{theta,dtheta,d2theta,y,dy,v},'file',[dirs.generated_functions, filesep, 'k3fun']);
% k3 = subs(k3,[y,dy,v],[0,0,0]);
% 
% disp('p');
% p = 2*dtheta*gv/alpha;
% disp('matlabFunction(p)');
% matlabFunction(p,'vars',{theta,dtheta,d2theta,y,dy,v},'file',[dirs.generated_functions, filesep, 'pfun']);
% p = subs(p,[y,dy,v],[0,0,0]);
% 
% disp('Done!');
% 
% Alin = [k1, k2, k3;
%     zeros(n-1,1), zeros(n-1), eye(n-1);
%     zeros(n-1,1), zeros(n-1), zeros(n-1)];
% Blin = [p; zeros(n-1); eye(n-1)];
% 
% matlabFunction(Alin, 'vars', {theta,dtheta,d2theta}, 'file', [dirs.generated_functions, filesep, 'AlinFun']);
% matlabFunction(Blin, 'vars', {theta,dtheta,d2theta}, 'file', [dirs.generated_functions, filesep, 'BlinFun']);

end