function dirs = fun_manage_dirs(system)
% Used to manage directories
% Modify this function to perform directory changes

warning off
rmpath([pwd,filesep,'Data_pendulum'])
rmpath([pwd,filesep,'Data_gorilla'])
rmpath([pwd,filesep,'GeneratedFunctions_pendulum'])
rmpath([pwd,filesep,'GeneratedFunctions_gorilla'])
warning on

dirs = struct;
dirs.generated_functions    = ['GeneratedFunctions', '_', system];
dirs.data                   = ['Data', '_', system];
dirs.sim_functions          = 'Simulink_functions';
dirs.gorilla                = 'Gorilla';

% Add dirs to path
for fn = fieldnames(dirs)'
    dirpath = [pwd, filesep, dirs.(char(fn))];
    if ~exist(dirpath,'dir')        % Directory does not exist
        mkdir(dirpath);
    end
    addpath(dirpath);
end

end